"gamfit"<-
  function(gam.data, h = 0, ngrid = 4000)
{
  formul <- paste("yval~", gam.data$form, sep = "")
  g2 <- rep(0, gam.data$ny)
  gam.data$yval <- gam.data$why
  why <- gam.data$why
  fit <- glm(formul, family = binomial, data = gam.data)
  g1 <- predict(fit)
  fhat <- g1 + g2
  phat <- exp(fhat)/(1 + exp(fhat))
  w <- phat * (1 - phat)
  z <- fhat + (why - phat)/w
  if(h != 0) {
    new <- waddmod(gam.data, g2 = g2, z = z, w = w, hopt = h, sameh
                   = T)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = h, sameh = T)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = h, sameh = T)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = h, sameh = T)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = h, sameh = T)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = h, ngrid = ngrid, sameh = T)
  }
  else {
    new <- waddmod(gam.data, g2 = g2, z = z, w = w)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = old$h)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = old$h)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = old$h)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = old$h, sameh = T)
    old <- new
    new <- waddmod(gam.data, g2 = old$g2, z = old$z, w = old$w, 
                   hopt = old$h, ngrid = ngrid, sameh = T)
  }
  new$ngrid<-ngrid			
  new
}
