"my.polymap" <- 
function(poly, add = F, xlab = "", ylab = "", axes = T, cex = 1.2, add.poly = T,
	...)
{
	pty.old <- par("pty")
	par(pty = "s")
	if(!add) {
		xrnge <- range(poly[, 1], na.rm = T)
		yrnge <- range(poly[, 2], na.rm = T)
		xd <- xrnge[2] - xrnge[1]
		yd <- yrnge[2] - yrnge[1]
		if(xd > yd) {
			xplot <- xrnge
			yplot <- NULL
			yplot[1] <- ((yrnge[2] + yrnge[1])/2) - xd/2
			yplot[2] <- ((yrnge[2] + yrnge[1])/2) + xd/2
		}
		else {
			yplot <- yrnge
			xplot <- NULL
			xplot[1] <- ((xrnge[2] + xrnge[1])/2) - yd/2
			xplot[2] <- ((xrnge[2] + xrnge[1])/2) + yd/2
		}
		plot(poly, xlim = xplot, ylim = yplot, type = "n", axes = axes,
			xlab = xlab, ylab = ylab, mgp = c(2.6000000000000001,
			2, 0), cex = cex)
	}
	if(add.poly) {
		polygon(poly, density = 0, ...)
	}
	par(pty = pty.old)
	invisible(0)
}

